diff --git a/cli.py b/cli.py
old mode 100644
new mode 100755
index 6056d38..aa73278
--- a/cli.py
+++ b/cli.py
@@ -1228,159 +1702,345 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return code, []
 
     def returnGroupLists(self, userlist):
+        """Print out a list of groups that match the given names or
+        wildcards.
 
-        uservisible=1
+        :param extcmds: a list of names or wildcards specifying
+           groups to list
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage        
+        """
+        return self._returnGroupLists(userlist)
+
+    def _returnGroupLists(self, userlist, summary=False):
+        # What data are we showing...
+        wts_map = {'hidden' : 'hidden',
+                   'language' : 'lang',
+                   'languages' : 'lang',
+                   'lang' : 'lang',
+                   'langs' : 'lang',
+                   'environment' : 'env',
+                   'environments' : 'env',
+                   'env' : 'env',
+                   'envs' : 'env',
+                   'package' : 'pkg',
+                   'packages' : 'pkg',
+                   'pkg' : 'pkg',
+                   'pkgs' : 'pkg',
+                   'available' : 'avail',
+                   'avail' : 'avail',
+                   'installed' : 'inst',
+                   'inst' : 'inst',
+                   'id' : 'id',
+                   'ids' : 'id',
+                   }
+        verb = self.verbose_logger.isEnabledFor(yum.logginglevels.DEBUG_3)
+        wts = {'hidden' : False,
+               'lang'   : None,
+               'env'    : None,
+               'pkg'    : None,
+               'inst'   : None,
+               'avail'  : None,
+               'id'     : verb}
             
-        if len(userlist) > 0:
-            if userlist[0] == 'hidden':
-                uservisible=0
-                userlist.pop(0)
+        ouserlist = userlist[:]
+        while userlist:
+            arg = userlist[0]
+            val = True
+            if arg.startswith('no'):
+                arg = arg[2:]
+                val = False
+            if arg not in wts_map:
+                break
+            wts[wts_map[arg]] = val
+            userlist.pop(0)
         if not userlist:
             userlist = None # Match everything...
 
-        installed, available = self.doGroupLists(uservisible=uservisible,
-                                                 patterns=userlist)
-        
-        if not installed and not available:
-            self.logger.error(_('Warning: No groups match: %s'),
-                              ", ".join(userlist))
-            return 0, []
+        if wts['inst'] is None and wts['avail'] is None:
+            wts['inst']  = True
+            wts['avail'] = True
 
-        def _out_grp(sect, group):
-            if not done:
-                self.verbose_logger.log(yum.logginglevels.INFO_2, sect)
-            msg = '   %s' % group.ui_name
-            if self.verbose_logger.isEnabledFor(yum.logginglevels.DEBUG_3):
-                msg += ' (%s)' % group.groupid
-            if group.langonly:
-                msg += ' [%s]' % group.langonly
-            self.verbose_logger.log(yum.logginglevels.INFO_2, '%s', msg)
+        if wts['lang'] is None and wts['pkg'] is None and wts['env'] is None:
+            wts['env'] = True
+            wts['pkg'] = True
 
-        done = False
-        for group in installed:
-            if group.langonly: continue
-            _out_grp(_('Installed Groups:'), group)
-            done = True
+        uv  = not wts['hidden']
+        dGL = self.doGroupLists(patterns=userlist,
+                                uservisible=uv, return_evgrps=True)
 
-        done = False
-        for group in installed:
-            if not group.langonly: continue
-            _out_grp(_('Installed Language Groups:'), group)
-            done = True
+        installed, available, ievgrps, evgrps = dGL
 
-        done = False
-        for group in available:
-            if group.langonly: continue
-            _out_grp(_('Available Groups:'), group)
-            done = True
+        if not wts['env']:
+            ievgrps = []
+            evgrps  = []
 
-        done = False
-        for group in available:
-            if not group.langonly: continue
-            _out_grp(_('Available Language Groups:'), group)
-            done = True
+        if not wts['inst']:
+            installed = []
+            ievgrps   = []
+        if not wts['avail']:
+            available = []
+            evgrps    = []
+        
+        done = []
+        def _out_grp(sect, groups):
+            if not groups:
+                return
 
-        return 0, [_('Done')]
+            done.append(sect)
+            if summary:
+                self.verbose_logger.log(yum.logginglevels.INFO_2,
+                                        "%s %u", sect, len(groups))
+                return
 
-    def returnGroupSummary(self, userlist):
+            self.verbose_logger.log(yum.logginglevels.INFO_2, sect)
 
-        uservisible=1
-            
-        if len(userlist) > 0:
-            if userlist[0] == 'hidden':
-                uservisible=0
-                userlist.pop(0)
-        if not userlist:
-            userlist = None # Match everything...
+            for group in groups:
+                msg = '   %s' % group.ui_name
+                if wts['id']:
+                    msg += ' (%s)' % group.compsid
+                if group.langonly:
+                    msg += ' [%s]' % group.langonly
+                self.verbose_logger.info('%s', msg)
 
-        installed, available = self.doGroupLists(uservisible=uservisible,
-                                                 patterns=userlist)
-        
-        def _out_grp(sect, num):
-            if not num:
-                return
-            self.verbose_logger.log(yum.logginglevels.INFO_2, '%s %u', sect,num)
-        done = 0
+        _out_grp(_('Installed environment groups:'), ievgrps)
+        _out_grp(_('Available environment groups:'), evgrps)
+
+        groups = []
         for group in installed:
             if group.langonly: continue
-            done += 1
-        _out_grp(_('Installed Groups:'), done)
+            if not wts['pkg']: continue
+            groups.append(group)
+        _out_grp(_('Installed groups:'), groups)
 
-        done = 0
+        groups = []
         for group in installed:
             if not group.langonly: continue
-            done += 1
-        _out_grp(_('Installed Language Groups:'), done)
+            if not wts['lang']: continue
+            groups.append(group)
+        _out_grp(_('Installed language groups:'), groups)
 
-        done = False
+        groups = []
         for group in available:
             if group.langonly: continue
-            done += 1
-        _out_grp(_('Available Groups:'), done)
+            if not wts['pkg']: continue
+            groups.append(group)
+        _out_grp(_('Available Groups:'), groups)
 
-        done = False
+        groups = []
         for group in available:
             if not group.langonly: continue
-            done += 1
-        _out_grp(_('Available Language Groups:'), done)
+            if not wts['lang']: continue
+            groups.append(group)
+        _out_grp(_('Available language groups:'), groups)
+
+        if not done:
+            self.logger.error(_('Warning: no environments/groups match: %s'),
+                              ", ".join(ouserlist))
+            return 0, []
 
         return 0, [_('Done')]
+
+    def returnGroupSummary(self, userlist):
+        """Print a summary of the groups that match the given names or
+        wildcards.
+
+        :param userlist: a list of names or wildcards specifying the
+           groups to summarise. If *userlist* is an empty list, all
+           installed and available packages will be summarised
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
+        return self._returnGroupLists(userlist, summary=True)
     
     def returnGroupInfo(self, userlist):
-        """returns complete information on a list of groups"""
+        """Print complete information about the groups that match the
+        given names or wildcards.
+
+        :param userlist: a list of names or wildcards specifying the
+           groups to print information about
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         for strng in userlist:
             group_matched = False
-            for group in self.comps.return_groups(strng):
-                self.displayPkgsInGroups(group)
-                group_matched = True
+
+            pkg_grp = True
+            grp_grp = True
+            if strng.startswith('@^'):
+                strng = strng[2:]
+                pkg_grp = False
+            elif strng.startswith('@'):
+                strng = strng[1:]
+                grp_grp = False
+
+            if grp_grp:
+                for evgroup in self.comps.return_environments(strng):
+                    self.displayGrpsInEnvironments(evgroup)
+                    group_matched = True
+            if pkg_grp:
+                for group in self.comps.return_groups(strng):
+                    self.displayPkgsInGroups(group)
+                    group_matched = True
 
             if not group_matched:
-                self.logger.error(_('Warning: Group %s does not exist.'), strng)
+                self.logger.error(_('Warning: group/environment %s does not exist.'), strng)
         
         return 0, []
         
-    def installGroups(self, grouplist):
-        """for each group requested do 'selectGroup' on them."""
-        
+    def installGroups(self, grouplist, upgrade=False):
+        """Mark the packages in the given groups for installation.
+
+        :param grouplist: a list of names or wildcards specifying
+           groups to be installed
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
+
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         pkgs_used = []
+
+        if not grouplist and self.conf.group_command == 'objects':
+            #  Do what "yum upgrade" does when upgrade_group_objects_upgrade is
+            # set.
+            for ievgrp in self.igroups.environments:
+                pkgs_used.extend(self._at_groupupgrade('@^' + ievgrp))
+            for igrp in self.igroups.groups:
+                pkgs_used.extend(self._at_groupupgrade('@'  + igrp))
         
+        done = False
         for group_string in grouplist:
+
+            grp_grp = True
+            pkg_grp = True
+            if group_string.startswith('@^'):
+                pkg_grp = False
+                group_string = group_string[2:]
+            elif group_string.startswith('@'):
+                grp_grp = False
+                group_string = group_string[1:]
+
             group_matched = False
-            for group in self.comps.return_groups(group_string):
+            groups = []
+            if grp_grp:
+                groups = self.comps.return_environments(group_string)
+            for group in groups:
                 group_matched = True
 
+                try:
+                    txmbrs = self.selectEnvironment(group.environmentid,
+                                                    upgrade=upgrade)
+                except yum.Errors.GroupsError:
+                    self.logger.critical(_('Warning: Environment group %s does not exist.'), group_string)
+                    continue
+                else:
+                    pkgs_used.extend(txmbrs)
+
+            groups = []
+            if pkg_grp:
+                groups = self.comps.return_groups(group_string)
+            for group in groups:
+                group_matched = True
             
                 try:
-                    txmbrs = self.selectGroup(group.groupid)
+                    txmbrs = self.selectGroup(group.groupid, upgrade=upgrade)
                 except yum.Errors.GroupsError:
-                    self.logger.critical(_('Warning: Group %s does not exist.'), group_string)
+                    self.logger.critical(_('Warning: Package group %s does not exist.'), group_string)
                     continue
                 else:
                     pkgs_used.extend(txmbrs)
 
             if not group_matched:
-                self.logger.error(_('Warning: Group %s does not exist.'), group_string)
+                self.logger.error(_('Warning: group %s does not exist.'), group_string)
                 continue
+            done = True
             
         if not pkgs_used:
-            return 0, [_('No packages in any requested group available to install or update')]
+            if self.conf.group_command == 'objects':
+                self.logger.critical(_("Maybe run: yum groups mark install (see man yum)"))
+            exit_status = 1
+            if upgrade:
+                # upgrades don't fail
+                exit_status = 0
+            if done:
+                # at least one group_string was a valid group
+                exit_status = 0
+            return exit_status, [_('No packages in any requested group available to install or update')]
         else:
             return 2, [P_('%d package to Install', '%d packages to Install', len(pkgs_used)) % len(pkgs_used)]
 
     def removeGroups(self, grouplist):
-        """Remove only packages of the named group(s). Do not recurse."""
+        """Mark the packages in the given groups for removal.
+
+        :param grouplist: a list of names or wildcards specifying
+           groups to be removed
+        :return: (exit_code, [ errors ])
+
+        exit_code is::
 
+            0 = we're done, exit
+            1 = we've errored, exit with error string
+            2 = we've got work yet to do, onto the next stage
+        """
         pkgs_used = []
         for group_string in grouplist:
-            try:
-                txmbrs = self.groupRemove(group_string)
-            except yum.Errors.GroupsError:
-                self.logger.critical(_('No group named %s exists'), group_string)
-                continue
-            else:
-                pkgs_used.extend(txmbrs)
+
+            grp_grp = True
+            pkg_grp = True
+            if group_string.startswith('@^'):
+                pkg_grp = False
+                group_string = group_string[2:]
+            elif group_string.startswith('@'):
+                grp_grp = False
+                group_string = group_string[1:]
+
+            groups = []
+            if grp_grp:
+                groups = self.comps.return_environments(group_string)
+                if not groups:
+                    self.logger.critical(_('No environment named %s exists'), group_string)
+            for group in groups:
+                try:
+                    txmbrs = self.environmentRemove(group.environmentid)
+                except yum.Errors.GroupsError:
+                    continue
+                else:
+                    pkgs_used.extend(txmbrs)
+
+            groups = []
+            if pkg_grp:
+                groups = self.comps.return_groups(group_string)
+                if not groups:
+                    self.logger.critical(_('No group named %s exists'), group_string)
+            for group in groups:
+                try:
+                    txmbrs = self.groupRemove(group.groupid)
+                except yum.Errors.GroupsError:
+                    continue
+                else:
+                    pkgs_used.extend(txmbrs)
                 
         if not pkgs_used:
+            if self.conf.group_command == 'objects':
+                self.logger.critical(_("Maybe run: yum groups mark remove (see man yum)"))
             return 0, [_('No packages to remove from groups')]
         else:
             return 2, [P_('%d package to remove', '%d packages to remove', len(pkgs_used)) % len(pkgs_used)]
@@ -1389,7 +2049,7 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
 
     def _promptWanted(self):
         # shortcut for the always-off/always-on options
-        if self.conf.assumeyes:
+        if (self.conf.assumeyes or self.conf.downloadonly) and not self.conf.assumeno:
             return False
         if self.conf.alwaysprompt:
             return True
@@ -1397,10 +2057,9 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         # prompt if:
         #  package was added to fill a dependency
         #  package is being removed
-        #  package wasn't explictly given on the command line
+        #  package wasn't explicitly given on the command line
         for txmbr in self.tsInfo.getMembers():
             if txmbr.isDep or \
-                   txmbr.ts_state == 'e' or \
                    txmbr.name not in self.extcmds:
                 return True
         
@@ -1408,11 +2067,11 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return False
 
     def usage(self):
-        ''' Print out command line usage '''
+        """Print out an explanation of command line usage."""
         sys.stdout.write(self.optparser.format_help())
 
     def shellUsage(self):
-        ''' Print out the shell usage '''
+        """Print out an explanation of the shell usage."""
         sys.stdout.write(self.optparser.get_usage())
     
     def _installable(self, pkg, ematch=False):
@@ -1468,9 +2127,9 @@ class YumBaseCli(yum.YumBase, output.YumOutput):
         return False
 
 class YumOptionParser(OptionParser):
-    '''Subclass that makes some minor tweaks to make OptionParser do things the
+    """Subclass that makes some minor tweaks to make OptionParser do things the
     "yum way".
-    '''
+    """
 
     def __init__(self,base, **kwargs):
         # check if this is called with a utils=True/False parameter
@@ -1488,13 +2147,23 @@ class YumOptionParser(OptionParser):
         self._addYumBasicOptions()
 
     def error(self, msg):
-        '''This method is overridden so that error output goes to logger. '''
+        """Output an error message, and exit the program.  This method
+        is overridden so that error output goes to the logger.
+
+        :param msg: the error message to output
+        """
         self.print_usage()
         self.logger.critical(_("Command line error: %s"), msg)
         sys.exit(1)
 
     def firstParse(self,args):
-        # Parse only command line options that affect basic yum setup
+        """Parse only command line options that affect basic yum
+        setup.
+
+        :param args: a list of command line options to parse
+        :return: a dictionary containing the values of command line
+           options
+        """
         try:
             args = _filtercmdline(
                         ('--noplugins','--version','-q', '-v', "--quiet", "--verbose"), 
@@ -1521,7 +2190,15 @@ class YumOptionParser(OptionParser):
         return ret
         
     def setupYumConfig(self, args=None):
-        # Now parse the command line for real
+        """Parse command line options.
+
+        :param args: the command line arguments entered by the user
+        :return: (opts, cmds)  opts is a dictionary containing
+           the values of command line options.  cmds is a list of the
+           command line arguments that were not parsed as options.
+           For example, if args is ["install", "foo", "--verbose"],
+           cmds will be ["install", "foo"].
+        """
         if not args:
             (opts, cmds) = self.parse_args()
         else:
@@ -1533,16 +2210,30 @@ class YumOptionParser(OptionParser):
         try:
             # config file is parsed and moving us forward
             # set some things in it.
+
+            if opts.tolerant or self.base.conf.tolerant: # Make it slower capt.
+                self.base.conf.recheck_installed_requires = True
                 
             # Handle remaining options
             if opts.assumeyes:
-                self.base.conf.assumeyes =1
-
-            #  Instead of going cache-only for a non-root user, try to use a
-            # user writable cachedir. If that fails fall back to cache-only.
-            if opts.cacheonly:
+                self.base.conf.assumeyes = 1
+            if opts.assumeno:
+                self.base.conf.assumeno  = 1
+            self.base.conf.downloadonly = opts.dlonly
+            self.base.conf.downloaddir = opts.dldir
+
+            # Store all the updateinfo filters somewhere...
+            self.base.updateinfo_filters['security'] = opts.security
+            self.base.updateinfo_filters['bugfix'] = opts.bugfix
+            self.base.updateinfo_filters['advs'] = self._splitArg(opts.advs)
+            self.base.updateinfo_filters['bzs']  = self._splitArg(opts.bzs)
+            self.base.updateinfo_filters['cves'] = self._splitArg(opts.cves)
+            self.base.updateinfo_filters['sevs'] = self._splitArg(opts.sevs)
+
+            #  Treat users like root as much as possible:
+            if not self.base.setCacheDir():
                 self.base.conf.cache = 1
-            elif not self.base.setCacheDir():
+            if opts.cacheonly:
                 self.base.conf.cache = 1
 
             if opts.obsoletes:
@@ -1574,11 +2265,8 @@ class YumOptionParser(OptionParser):
                 if opts.color != 'auto':
                     self.base.term.reinit(color=opts.color)
 
-            if opts.disableexcludes:
-                disable_excludes = self._splitArg(opts.disableexcludes)
-            else:
-                disable_excludes = []
-            self.base.conf.disable_excludes = disable_excludes
+            self.base.conf.disable_excludes = self._splitArg(opts.disableexcludes)
+            self.base.conf.disable_includes = self._splitArg(opts.disableincludes)
 
             for exclude in self._splitArg(opts.exclude):
                 try:
@@ -1610,10 +2298,6 @@ class YumOptionParser(OptionParser):
                     self.base.usage()
                     sys.exit(1)
 
-            # make sure the added repos are setup.        
-            if len(opts.repos) > 0:
-                self.base._getRepos(doSetup=True)
-
             # Disable all gpg key checking, if requested.
             if opts.nogpgcheck:
                 #  Altering the normal configs. doesn't work too well, esp. with
@@ -1623,7 +2307,7 @@ class YumOptionParser(OptionParser):
                     repo._override_sigchecks = True
                             
         except ValueError, e:
-            self.logger.critical(_('Options Error: %s'), e)
+            self.logger.critical(_('Options error: %s'), e)
             self.base.usage()
             sys.exit(1)
          
@@ -1640,10 +2324,18 @@ class YumOptionParser(OptionParser):
         sys.exit(1)
 
     def getRoot(self,opts):
+        """Return the root location to use for the yum operation.
+        This location can be changed by using the --installroot
+        option.
+
+        :param opts: a dictionary containing the values of the command
+           line options
+        :return: a string representing the root location
+        """
         self._checkAbsInstallRoot(opts)
         # If the conf file is inside the  installroot - use that.
         # otherwise look for it in the normal root
-        if opts.installroot:
+        if opts.installroot and opts.installroot.lstrip('/'):
             if os.access(opts.installroot+'/'+opts.conffile, os.R_OK):
                 opts.conffile = opts.installroot+'/'+opts.conffile
             elif opts.conffile == '/etc/yum/yum.conf':
@@ -1701,6 +2393,9 @@ class YumOptionParser(OptionParser):
         group.add_option("--showduplicates", dest="showdupesfromrepos",
                         action="store_true",
                 help=_("show duplicates, in repos, in list/search commands"))
+        group.add_option("--show-duplicates", dest="showdupesfromrepos",
+                         action="store_true",
+                         help=SUPPRESS_HELP)
         group.add_option("-e", "--errorlevel", dest="errorlevel", default=None,
                 help=_("error output level"), type='int',
                 metavar='[error level]')
@@ -1713,6 +2408,10 @@ class YumOptionParser(OptionParser):
                         help=_("verbose operation"))
         group.add_option("-y", "--assumeyes", dest="assumeyes",
                 action="store_true", help=_("answer yes for all questions"))
+        group.add_option("--assumeno", dest="assumeno",
+                action="store_true", help=_("answer no for all questions"))
+        group.add_option("--nodeps", dest="assumeno", # easter egg :)
+                action="store_true", help=SUPPRESS_HELP)
         group.add_option("--version", action="store_true", 
                 help=_("show Yum version and exit"))
         group.add_option("--installroot", help=_("set install root"), 
@@ -1730,6 +2429,9 @@ class YumOptionParser(OptionParser):
         group.add_option("", "--disableexcludes", default=[], action="append",
                 help=_("disable exclude from main, for a repo or for everything"),
                         metavar='[repo]')
+        group.add_option("", "--disableincludes", default=[], action="append",
+                help=_("disable includepkgs for a repo or for everything"),
+                        metavar='[repo]')
         group.add_option("--obsoletes", action="store_true", 
                 help=_("enable obsoletes processing during updates"))
         group.add_option("--noplugins", action="store_true", 
@@ -1748,9 +2450,29 @@ class YumOptionParser(OptionParser):
                 help=_("control whether color is used"))
         group.add_option("", "--releasever", dest="releasever", default=None, 
                 help=_("set value of $releasever in yum config and repo files"))
+        group.add_option("--downloadonly", dest="dlonly", action="store_true",
+                help=_("don't update, just download"))
+        group.add_option("--downloaddir", dest="dldir", default=None,
+                help=_("specifies an alternate directory to store packages"))
         group.add_option("", "--setopt", dest="setopts", default=[],
                 action="append", help=_("set arbitrary config and repo options"))
 
+        # Updateinfo options...
+        group.add_option("--bugfix", action="store_true", 
+                help=_("Include bugfix relevant packages, in updates"))
+        group.add_option("--security", action="store_true", 
+                help=_("Include security relevant packages, in updates"))
+
+        group.add_option("--advisory", "--advisories", dest="advs", default=[],
+                action="append", help=_("Include packages needed to fix the given advisory, in updates"))
+        group.add_option("--bzs", default=[],
+                action="append", help=_("Include packages needed to fix the given BZ, in updates"))
+        group.add_option("--cves", default=[],
+                action="append", help=_("Include packages needed to fix the given CVE, in updates"))
+        group.add_option("--sec-severity", "--secseverity", default=[],
+                         dest="sevs", action="append",
+                help=_("Include security relevant packages matching the severity, in updates"))
+
         
 def _filtercmdline(novalopts, valopts, args):
     '''Keep only specific options from the command line argument list
diff --git a/completion-helper.py b/completion-helper.py
new file mode 100755
index 0000000..c0e5a28
--- /dev/null
+++ b/completion-helper.py
@@ -0,0 +1,96 @@
+#!/usr/bin/python -t
+# -*- coding: utf-8 -*-
+#
+# Copyright (C) 2011 Ville Skyttä
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software Foundation,
+# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
+
+
+import shlex
+import sys
+
+import cli
+import yumcommands
+from yum.Errors import GroupsError, ConfigError, RepoError
+
+
+class GroupsCompletionCommand(yumcommands.GroupsCommand):
+    def doCommand(self, base, basecmd, extcmds):
+        cmd, extcmds = self._grp_cmd(basecmd, extcmds)
+        # case insensitivity is fine here because groupinstall etc are that too
+        installed, available = base.doGroupLists(
+            patterns=[get_pattern(extcmds)])
+        if extcmds[0] in ("installed", "all"):
+            for group in installed:
+                print group.ui_name
+        if extcmds[0] in ("available", "all"):
+            for group in available:
+                print group.ui_name
+
+class ListCompletionCommand(yumcommands.ListCommand):
+    def doCommand(self, base, basecmd, extcmds):
+        def printPkgs(pkgs):
+            for pkg in pkgs:
+                if base.allowedMultipleInstalls(pkg):
+                    print pkg.nvra
+                else:
+                    print pkg.na
+
+        ypl = base.doPackageLists(pkgnarrow=extcmds[0],
+                                  patterns=[get_pattern(extcmds)])
+        if extcmds[0] in ("installed", "all"):
+            printPkgs(ypl.installed)
+        if extcmds[0] in ("available", "all"):
+            printPkgs(ypl.available)
+
+class RepoListCompletionCommand(yumcommands.RepoListCommand):
+    def doCommand(self, base, basecmd, extcmds):
+        import fnmatch
+        pattern = get_pattern(extcmds)
+        for repo in base.repos.repos.values():
+            if fnmatch.fnmatch(repo.id, pattern) \
+                    and (extcmds[0] == "all" or
+                         (extcmds[0] == "enabled" and repo.isEnabled()) or
+                         (extcmds[0] == "disabled" and not repo.isEnabled())):
+                print repo.id
+
+
+def get_pattern(extcmds):
+    if len(extcmds) > 1:
+        try: return shlex.split(extcmds[-1])[0] + "*"
+        except (ValueError, IndexError): pass
+    return "*"
+
+def main(args):
+    base = cli.YumBaseCli()
+    base.yum_cli_commands.clear()
+    base.registerCommand(GroupsCompletionCommand())
+    base.registerCommand(ListCompletionCommand())
+    base.registerCommand(RepoListCompletionCommand())
+    base.getOptionsConfig(args)
+    base.parseCommands()
+    try:
+        for repo in base.repos.listEnabled():
+            repo.skip_if_unavailable = True
+        base.doCommands()
+    except (GroupsError, ConfigError, RepoError), e:
+    # Any reason to not just catch YumBaseError ?
+        base.logger.error(e)
+
+if __name__ == "__main__":
+    try:
+        main(sys.argv[1:])
+    except KeyboardInterrupt, e:
+        sys.exit(1)
